package hashmap;

import java.util.HashMap;
import java.util.ListIterator;

/**
 *
 * @author Matthijs Kuiper
 */
public class DataFrame {
    HashMap content = new HashMap();

    public DataFrame(String data, DataFormat format){
        this.unpack(data, format);
    }

    public DataFrame(int[] data, DataFormat format){
        String data_str = data.toString(); //Hier wil je dat data een string wordt ipv. int[]
        this.unpack(data_str, format);
    }

    protected void unpack(String data, DataFormat format){
        ListIterator<Variable> it = format.getIterator();
        Variable currentVariable = null;
        while(it.hasNext()){
            currentVariable = it.next();
            String value_raw = data.substring(currentVariable.getBit_start(), currentVariable.getBit_end());
            int value_int = Integer.parseInt(value_raw, 2); //parsed to a decimal integer.
            double value_double = currentVariable.getMultiplier() * (double) value_int + currentVariable.getSommation();
            content.put(currentVariable.getName(), value_double);
        }
    }

    public Double get(Object key){
        return (Double) content.get(key);
    }
}
